<?php
	/**************************************************************************************
	* Clases y funciones generales *
	****************************************************************************************/	
	if ( !defined('__DIR__') ) define('__DIR__', dirname(__FILE__));
	// header('Content-Type: text/html; charset=UTF-8');
	date_default_timezone_set('America/Argentina/Buenos_Aires');	
		
	// require_once('geoip.inc');
  
	// $gi = geoip_open("/absolute/path/to/GeoIP.dat",GEOIP_STANDARD);
		  
	// $country_code = geoip_country_code_by_addr($gi, $_SERVER['REMOTE_ADDR']);  
	// geoip_close($gi);
	
	
	$path = dirname(__FILE__).'/fpdf16/font/';
	define('FPDF_FONTPATH', $path);
	define('F3_CAMPO', 2);
	define('F3_TABLA', 1);
	define('WIDTH_COL', 98);	
	
	define('WIDTH_ROW', 1100);
	// define('WIDTH_ROW_F3', 700);
	define('WIDTH_ROW_F3', 550);
	define('WIDTH_ROW_ADMIN', 700);
	
	include dirname(__FILE__).'/config.php';
	include dirname(__FILE__).'/clsEncrypt.php';
	include dirname(__FILE__).'/clsSqlServer.php';
	include dirname(__FILE__).'/clsUserAdmin.php';
	include dirname(__FILE__).'/clsMetaData.php';
	include dirname(__FILE__).'/clsSXM.php';
	include dirname(__FILE__).'/../fpdf16/fpdf.php';
	include dirname(__FILE__).'/clsNumToString.php';
	include dirname(__FILE__).'/clsPage.php';


	//base de datos
	$SqlSrv		= new SqlServer();
	//meta data
	$MetaData	= new MetaData($SqlSrv);
	//menu
	$SXM		= new SXM($SqlSrv);
	//ClsUsuario
	$UserAdmin 	= new UserAdmin($SqlSrv);	
	//fpdf
	$pdf 		= new FPDF();	
	//Numeros a letras
	$NumToString= new NumToString();
	
	$Encrypt	= new Encrypt();

	$conectDbInit = ( isset($conectDbInit) && !isset($_REQUEST["conectDbInit"]) ) ? $conectDbInit :  0 ;
	if($conectDbInit){
		$SqlSrv->dbConnect();
	}
	
	//imprime el array por pantalla
	function pr($arr=array()){
		echo "<pre>";
		print_r($arr);
		echo "</pre>";
	}
	//devuelve los tipos de valores aceptados
	function getTypeCol($type=""){
		if(empty($type)) return false;
		$type = strtoupper($type);
		switch($type){
			case "C":
				$typeRDB = "VARCHAR";
			break;
			case "N":
				$typeRDB = "INT";
			break;
			case "F":
				$typeRDB = "DOUBLE";
			break;
			default:
				$typeRDB = "VARCHAR";
		}
		return strtoupper($typeRDB);
	}
	//valida si es requerido o no el campo
	function getRequired($required="N"){
		$required = strtoupper($required);
		$required = ( $required != "S" && $required != "N" )? "N" : $required;
		if($required == "S"){
			$req = "NOT NULL ";
		}
		if($required == "N"){
			$req = "default NULL ";
		}
		return $req;
	}
	//ejecuto la funcion del menu
	function AxTable( $funcion="", $modulo="" ){
		$Encrypt = new Encrypt();
		$funcion = ( !empty($funcion) )? $funcion : "" ;		
		$modulo  = ( !empty($modulo) )? $modulo : "" ;
		$link = ("tpl.php?table=".$Encrypt->encode($funcion)."&modulo=".$modulo);
		return $link;
	}
	//casteo el valor del campo	
	function getCastField($type="", $field=""){
		if(empty($type)) return false;
		if(empty($field)) return false;
		$type = strtoupper($type);
		switch($type){
			case "C":
				$field = $field;
				return $field;
			break;
			case "N":
				$field = (int) $field;
				return $field;
			break;
			case "F":
				$field = (float) $field;
				return $field;
			break;
			default:
				return $field;
		}
	}
	//devuelvo el array con los campos BROWSE  --> Si  (ES DECIR LOS QUE VOY A MOSTRAR AL ARMAR LA GRILLA)
	function retArrayBrowse( $arr = array() )	{
		$arrAux = array();
		if($arr){
			for( $i=0;$i < count($arr); $i++ ){
				if( $arr[$i]['X3_BROWSE'] == 'S' ){
					$arrAux[] = $arr[$i];
				}
			}
		}
		return $arrAux;
	}
	
	//devuelvo el array con los campos VISUAL  --> Si  (ES DECIR LOS QUE VOY A MOSTRAR AL ARMAR EL FORMULARIO ABM)
	function retArrayVisual( $arr = array() ){
		$arrAux = array();
		if($arr){
			for( $i=0;$i < count($arr); $i++ ){
				if( $arr[$i]['X3_VISUAL'] == 'S' ){
					$arrAux[] = $arr[$i];
				}
			}
		}
		return $arrAux;
	}
	
	//devuelvo el array con los campos VISUAL  --> Si  (ES DECIR LOS QUE VOY A MOSTRAR AL ARMAR EL FORMULARIO ABM)
	function retArrayObrigat( $arr = array() ){
		$arrAux = array();
		if($arr){
			for( $i=0;$i < count($arr); $i++ ){
				if( $arr[$i]['X3_OBRIGAT'] == 'S' ){
					$arrAux[] = $arr[$i];
				}
			}
		}
		return $arrAux;
	}
	
	
	function getDateChar($fecha=''){
		$newFecha = '';
		if(!empty($fecha) && strlen($fecha) == 8 ){
			// $newFecha = substr($fecha,0,4).'-'.substr($fecha,4,2).'-'.substr($fecha,6,2).' 00:00:00';
			// $newFecha = substr($fecha,0,4).'-'.substr($fecha,4,2).'-'.substr($fecha,6,2);
			// $newFecha = substr($fecha,0,2).'/'.substr($fecha,2,2).'/'.substr($fecha,4,4);
			$newFecha = substr($fecha,6,2).'/'.substr($fecha,4,2).'/'.substr($fecha,0,4);
		}
		return $newFecha;
	}
	
	function getCharDate($fecha=''){
		$newFecha = '';
		$arrFecha = array();
		if(!empty($fecha) && strlen($fecha) == 10 ){
			// $newFecha = substr($fecha,0,4).'-'.substr($fecha,4,2).'-'.substr($fecha,6,2).' 00:00:00';
			$arrFecha = explode("/", $fecha);
			$newFecha = $arrFecha[2].$arrFecha[1].$arrFecha[0];
		}
		return $newFecha;
	}
	
	function getHour($hora=''){
		$newHour = '';
		if(!empty($hora)){
			$newHour = substr($hora,0,2).":".substr($hora,2,2);
		}
		return $newHour;
	}
	
	$arrMeses = array(
		1 => array('Ene', 'Enero'),
		2 => array('Feb', 'Febrero'),
		3 => array('Mar', 'Marzo'),
		4 => array('Abr', 'Abril'),
		5 => array('May', 'Mayo'),
		6 => array('Jun', 'Junio'),
		7 => array('Jul', 'Julio'),
		8 => array('Ago', 'Agosto'),
		9 => array('Sep', 'Septiembre'),
		10 => array('Oct', 'Octubre'),
		11 => array('Nov', 'Noviembre'),
		12 => array('Dic', 'Diciembre')
	);
	
	function getDebeHaber($cuit, $tipdoc=''){
		global $MetaData;
		$arrMotivosContables = array();
		$arrMotivosContables = $MetaData->obtMotivosContables($cuit);
		if(!empty($tipdoc)){
			for($i=0 ; $i < count($arrMotivosContables); $i++ ){
				$MC = strtolower( trim($arrMotivosContables[$i]['MC_TIPDOC']) );
				if( $MC  == strtolower( trim($tipdoc) ) ){				
					return $arrMotivosContables[$i]['MC_DEHA'];
				}
			}
		}
		return false;
	}
	
	function _log($CUITUSUARIO='', $CUITEMPRESA='', $LOG=''){
		global $SqlSrv;
		$LOG_FECHA = str_replace('-','',date('Y-m-d'));
		$LOG_HORA  = substr(str_replace(':','',date('H:i:s')),0,4);
		if(!empty($CUITUSUARIO) && !empty($LOG) ){
			$query = "INSERT INTO slog (CUITUSUARIO, CUITEMPRESA, LOG, LOG_FECHA, LOG_HORA) VALUES ('$CUITUSUARIO', '$CUITEMPRESA', '$LOG', '$LOG_FECHA', '$LOG_HORA') ";
			// echo $query;
			$SqlSrv->dbQueryInsert($query);
		}		
	}
	
	function ValidaMail($pMail){ 	
		$regex = '/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$/'; 
		if (preg_match($regex, $pMail)){
			 return true;
		} else { 
			 return false;
		}				
	}
	
	function generarCodigo( $longitud ){
		$key = '';
		$pattern = '1234567890abcdefghijklmnopqrstuvwxyz';
		$max = strlen($pattern)-1;
		for($i=0;$i < $longitud;$i++) $key .= $pattern{mt_rand(0,$max)};
		return $key;
	}	
?>